/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the StorageRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &StorageRequest{}

// StorageRequest struct for StorageRequest
type StorageRequest struct {
	Label *string `json:"label,omitempty"`
	Type  *string `json:"type,omitempty"`
}

// NewStorageRequest instantiates a new StorageRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewStorageRequest() *StorageRequest {
	this := StorageRequest{}
	return &this
}

// NewStorageRequestWithDefaults instantiates a new StorageRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewStorageRequestWithDefaults() *StorageRequest {
	this := StorageRequest{}
	return &this
}

// GetLabel returns the Label field value if set, zero value otherwise.
func (o *StorageRequest) GetLabel() string {
	if o == nil || IsNil(o.Label) {
		var ret string
		return ret
	}
	return *o.Label
}

// GetLabelOk returns a tuple with the Label field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *StorageRequest) GetLabelOk() (*string, bool) {
	if o == nil || IsNil(o.Label) {
		return nil, false
	}
	return o.Label, true
}

// HasLabel returns a boolean if a field has been set.
func (o *StorageRequest) HasLabel() bool {
	if o != nil && !IsNil(o.Label) {
		return true
	}

	return false
}

// SetLabel gets a reference to the given string and assigns it to the Label field.
func (o *StorageRequest) SetLabel(v string) {
	o.Label = &v
}

// GetType returns the Type field value if set, zero value otherwise.
func (o *StorageRequest) GetType() string {
	if o == nil || IsNil(o.Type) {
		var ret string
		return ret
	}
	return *o.Type
}

// GetTypeOk returns a tuple with the Type field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *StorageRequest) GetTypeOk() (*string, bool) {
	if o == nil || IsNil(o.Type) {
		return nil, false
	}
	return o.Type, true
}

// HasType returns a boolean if a field has been set.
func (o *StorageRequest) HasType() bool {
	if o != nil && !IsNil(o.Type) {
		return true
	}

	return false
}

// SetType gets a reference to the given string and assigns it to the Type field.
func (o *StorageRequest) SetType(v string) {
	o.Type = &v
}

func (o StorageRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o StorageRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Label) {
		toSerialize["label"] = o.Label
	}
	if !IsNil(o.Type) {
		toSerialize["type"] = o.Type
	}
	return toSerialize, nil
}

type NullableStorageRequest struct {
	value *StorageRequest
	isSet bool
}

func (v NullableStorageRequest) Get() *StorageRequest {
	return v.value
}

func (v *NullableStorageRequest) Set(val *StorageRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableStorageRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableStorageRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableStorageRequest(val *StorageRequest) *NullableStorageRequest {
	return &NullableStorageRequest{value: val, isSet: true}
}

func (v NullableStorageRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableStorageRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
